<app-loading *ngIf="isLoading"></app-loading>
<div class="app-card">
  <form nz-form [formGroup]="searchForm">
    <div class="app-row" nz-row [nzGutter]="[30, 0]">
      <div nz-col nzXs="12" nzLg="8">
        <mb-date-picker [mbShowTime]="true" mbMode="time" mbFormat="dd/MM/yyyy HH:mm:ss"
          [mbType]="isSubmitted && (searchForm.controls['fromDate'].errors || searchForm.errors?.['rangeDateError']) ? 'error' : 'default'"
          [mbShowError]="isSubmitted && (searchForm.controls['fromDate'].errors || searchForm.errors?.['rangeDateError']) != null"
          [mbErrors]="searchForm.errors?.['rangeDateError'] ? searchForm.errors : searchForm.controls['fromDate'].errors"
          [mbErrorDefs]="[
          { errorName: 'required', errorDescription: 'system.validate.required' | translate: {'param': 'system.table.fromDate' | translate }},
          { errorName: 'rangeDateError', errorDescription: 'system.validate.rangeDate.pareDate' | translate:
          {'fromDate': 'system.table.fromDate' | translate, 'toDate': 'system.table.toDate' | translate}}
          ]"
          mbPlaceholderText="--{{'system.sessionHistory.label.attributes.fromDate' | translate}}--"
          mbLabelText="{{'system.sessionHistory.label.attributes.fromDate' | translate}} <span class='label__required'>*</span>"
          formControlName="fromDate"></mb-date-picker>
      </div>
      <div nz-col nzXs="12" nzLg="8">
        <mb-date-picker [mbShowTime]="true" mbMode="time" mbFormat="dd/MM/yyyy HH:mm:ss"
          [mbType]="isSubmitted && (searchForm.controls['toDate'].errors || searchForm.errors?.['rangeDateError']) ? 'error' : 'default'"
          [mbShowError]="isSubmitted && searchForm.controls['toDate'].errors != null"
          [mbErrors]="searchForm.controls['toDate'].errors"
          [mbErrorDefs]="[
          { errorName: 'required', errorDescription: 'system.validate.required' | translate: {'param': 'system.table.toDate' | translate }}]"
          mbPlaceholderText="--{{'system.sessionHistory.label.attributes.toDate' | translate}}--"
          mbLabelText="{{'system.sessionHistory.label.attributes.toDate' | translate}} <span class='label__required'>*</span>"
          formControlName="toDate"></mb-date-picker>
      </div>
      <div nz-col nzXs="12" nzLg="8">
        <mb-input-text formControlName="username"
        [mbType]="isSubmitted && searchForm.controls['username'].errors ? 'error' : 'default'" [mbMaxLength]="255"
        [mbShowError]="isSubmitted && searchForm.controls['username'].errors != null" [mbErrors]="searchForm.controls['username'].errors"
        [mbErrorDefs]="[{ errorName: 'maxlength', errorDescription: 'system.validate.maxLength' | translate: {'numberLength': '255' }},
          { errorName: 'required', errorDescription: 'system.validate.required' | translate: {'param': 'system.sessionHistory.label.attributes.username' | translate }}]"
        mbPlaceholderText="--{{'system.sessionHistory.label.attributes.username' | translate}}--"
        mbLabelText="{{'system.sessionHistory.label.attributes.username' | translate}} <span class='label__required'>*</span>"></mb-input-text>
      </div>
      <div nz-col nzXs="12" nzLg="8">
        <mb-input-text formControlName="device"
          mbPlaceholderText="--{{'system.sessionHistory.label.attributes.device' | translate}}--"
          mbLabelText="{{'system.sessionHistory.label.attributes.device' | translate}}">
        </mb-input-text>
      </div>
      <div nz-col nzXs="12" nzLg="8">
        <mb-select [mbDataSelects]="listApp" mbKeyLabel="appName" mbKeyValue="appId"
          mbPlaceholder="--{{'system.sessionHistory.label.attributes.app' | translate}}--"
          mbLabelText="{{'system.sessionHistory.label.attributes.app' | translate}}"
          formControlName="appId"></mb-select>
      </div>
      <div nz-col nzXs="12" nzLg="8">
        <mb-input-text formControlName="function"
          mbPlaceholderText="--{{'system.sessionHistory.label.attributes.resource' | translate}}--"
          mbLabelText="{{'system.sessionHistory.label.attributes.resource' | translate}}">
        </mb-input-text>
      </div>

      <div nz-col nzXs="24" nzLg="24" class="button-search">
        <mb-button mbButtonType="NO_BORDER" mbButtonSize="VERY_LARGE" (click)="search()"
                   mbButtonAvailableStyle="SEARCH" mbButtonText="{{'common.label.search' | translate}}">
        </mb-button>
      </div>
    </div>
  </form>
</div>
<div class="app-list">
  <div class="data-table" oncontextmenu="return false;">
    <nz-table #basicTable [nzData]="listData || []" [nzShowPagination]="false" [nzPageSize]="pageable.totalElements"
      [nzScroll]="listData.length > 7 ? { y: '380px' } : {}" nzSize='small'>
      <thead>
        <tr class="table-header">
          <th scope="col"class="text-nowrap text-center" nzWidth="50px" nzLeft='0'>{{'system.table.stt' | translate}}</th>
          <th scope="col" class="text-nowrap text-center">{{'system.sessionHistory.label.table.loginTime' | translate}}</th>
          <th scope="col" class="text-nowrap">{{'system.sessionHistory.label.table.username' | translate}}</th>
          <th scope="col" class="text-nowrap">{{'system.sessionHistory.label.table.device' | translate}}</th>
          <th scope="col" class="text-nowrap">{{'system.sessionHistory.label.table.appName' | translate}}</th>
          <th scope="col" class="text-nowrap">{{'system.sessionHistory.label.table.featureName' | translate}}</th>
          <th scope="col" class="text-nowrap text-center">{{'system.sessionHistory.label.table.fromDate' | translate}}</th>
          <th scope="col" nzWidth="100px" nzRight="0px" class="text-nowrap text-center"></th>
        </tr>
      </thead>
      <tbody>
        <tr class="row-table" *ngFor="let data of basicTable.data ;let i = index; trackBy: trackByFn">
          <td class="text-center" nzWidth="50px" nzLeft='0'>{{ validateService.getRowIndex(i, pageable.currentPage, pageable.size) }}</td>
          <td class="text-center">{{ data.loginTime | date: 'dd/MM/yyyy HH:mm:ss' }}</td>
          <td>{{ data?.username }}</td>
          <td>{{ data?.deviceName }}</td>
          <td>{{ data?.appName }}</td>
          <td>{{ data?.featureName }}</td>
          <td class="text-center">{{ data.fromDate | date: 'dd/MM/yyyy HH:mm:ss' }}</td>
          <td class="text-center" nzWidth="100px" nzRight="0px">
            <mb-button *ngIf="data.fromDate" mbButtonType="ONLY_ICON" mbButtonIconType="AWESOME" mbPrefixIcon="far fa-eye"
              (click)="showDetail(data, footerTmpl)" nzTooltipTitle="{{'common.button.view' | translate}}"
              nzTooltipPlacement="bottom" nz-tooltip></mb-button>
          </td>
        </tr>
      </tbody>
    </nz-table>
  </div>
</div>
<div class="pagination" *ngIf="listData && listData.length > 0">
  <div class="pagination__table-info">
    <img alt="idea.svg" class="pagination__table-info--icon" src="assets/images/icon/idea.svg" />
    <span class="pagination__table-info--text">Tìm thấy {{ pageable?.totalElements }} kết quả, hiển thị từ
      {{ pageable.size * (pageable.currentPage - 1) + 1 }} đến
      {{ pageable.size * (pageable.currentPage - 1) + listData.length }}</span>
  </div>
  <nz-pagination [(nzPageIndex)]="pageable && pageable.currentPage" [nzTotal]="pageable.totalElements"
    [nzPageSize]="pageable.size" (nzPageIndexChange)="search($event)" class="pagination__icon">
  </nz-pagination>
</div>

<ng-template #footerTmpl>
  <div class="sh-footer-center">
    <mb-button mbButtonType="BORDER" mbButtonSize="VERY_LARGE" (click)="modalRef?.getContentComponent().close()"
      mbButtonAvailableStyle="DEFAULT" mbButtonText="{{'common.button.close' | translate}}">
    </mb-button>
  </div>
</ng-template>
